import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.*;
import java.lang.*;

class ServerInput implements Runnable {
  MudClient client;
  InputStream in;
  int needed = -1;
  
  ServerInput(MudClient c, InputStream i) {
    client = c;
    in = i;
  }
  
  public void run() {
    byte buf[];
    int c;
    
    StringBuffer info;
    StringBuffer cur;
    
    String infoStr;
    String numNoZonesStr;
    int numNoZones;
    char numNoZonesChar;
    int length;
    
    info = new StringBuffer();
    cur = new StringBuffer();
    
    
    //System.out.println("Running thread");
    while (true) {
      try {
	c = in.read();
	
	if (c < 0) {
	  break;
	}
        if (c == 13) {
	  //System.out.println("ignoring CR");
	}
	else if (c == 10) {
	  infoStr = cur.toString();
	  if (infoStr.startsWith("playing")) {
	    info.setLength(0);
	    info.append(infoStr);
	    //System.out.println("String was: "+info.toString());
	    length = infoStr.length();
	    numNoZonesChar = infoStr.charAt(length-1);
	    numNoZones = (int)numNoZonesChar - 48;
	    //System.out.println("num of NoZones: "+numNoZones);
	    needed = numNoZones;
	    cur.setLength(0);
	  }
	  else if (needed > 0) {
	    info.append((char)32);
	    info.append(infoStr);
	    needed--;
	    //System.out.println("HA!"+info.toString()+"n: "+needed);
	    if (needed == 0) client.output(info.toString());
	    cur.setLength(0);
	  }
	  else {
	    client.output(cur.toString());
	    cur.setLength(0);
	  }
	}
	else {
	  cur.append((char) c);
	}
	
      }
      catch (IOException e) {
        System.out.println("io exception");
	break;
      }
      
    }
    client.output("<<DISCONNECTED>>");
    System.out.println("run exiting\n");
  }
}

public class MudClient {
  Socket conn;
  OutputStream out;
  InputStream in;
  ServerInput input_obj;
  Thread input_thread = null;
  Mudwin window;
  String host;
  int port;
  String command;
  int zone_num;
  
  MudApplet A;
  
  MudClient(String host, int port, MudApplet A) {
    this.host = host;
    this.port = port;
    this.A = A;
  }
  
  public void connect() {
    try {
      conn = new Socket(host, port);
      System.out.println("connected to " + host + "/" + port);
    }
    catch ( UnknownHostException e) {
    }
    catch ( IOException e ) {
    }
    
    try {
      out = conn.getOutputStream();
      in = new BufferedInputStream(conn.getInputStream());
    }
    catch (IOException e) {
      System.out.println("Got exception: " + e);
      return;
    }
    
    input_obj = new ServerInput(this, in);
    System.out.println("constructor returns");
    input_thread = new Thread(input_obj);
    input_thread.start();
  }
  
  public void start() {
    System.out.println("in start method");
    if (input_thread == null) {
      input_thread = new Thread(input_obj);
      input_thread.start();
    }
    else {
      input_thread.resume();
    }
  }
  
  public void stop() {
    input_thread.suspend();
  }
  
  public void destroy() {
    input_thread.stop();
  }
  
  public void setWindow(Mudwin w) {
    window = w;
  }
  
  public void input(String s) {
    byte buf[] = new byte[s.length()];
    s.getBytes(0, s.length(), buf, 0);
    
    window.addLine(s);
    
    try {
      out.write(buf);
      out.write(10);
    }
    catch (IOException e) {
    }
  }
  
  public void output(String s) {
    StringTokenizer w = new StringTokenizer(s);
    while (w.hasMoreTokens()) {
      String ww = w.nextToken();
      
      String IDU = "I don't understand that.";
      String command = s;
      
      if (s.equals(IDU)) {
	A.I_dont_understand(s);
      }
      else if (ww.equals("playing")) {
	//System.out.println("PLAYING!!!!!!");
	A.playing(ww, w);
	int x_dim = Integer.valueOf(w.nextToken()).intValue(); 
	int y_dim = Integer.valueOf(w.nextToken()).intValue(); 
	A.drawCheckerboard(x_dim, y_dim);
	//System.out.println("X x Y: " + x_dim + y_dim);
	zone_num = Integer.valueOf(w.nextToken()).intValue();
	//System.out.println("zone_num: " + zone_num);
	A.setupNoZones(zone_num);
	for (int j=0; j<zone_num; j++) {
	  A.setNoZone(j,
		      Integer.valueOf(w.nextToken()).intValue(),
		      Integer.valueOf(w.nextToken()).intValue());
	}
	A.painter();
      }
      else if (ww.equals("GO")) {
	System.out.println("GO!!!!!!");
	int x = Integer.valueOf(w.nextToken()).intValue(); 
	int y = Integer.valueOf(w.nextToken()).intValue(); 
	System.out.println("Going to: " + x + y);
	A.go(x, y);
	A.painter();
      }
      else if (ww.equals("NO")) {
	System.out.println("NO!!!!!!");
	A.playAhOh();
      }
      else if (ww.equals("sound")) {
	System.out.println("SOUND!!!!!!");
	String sound = w.nextToken();
	A.playEverything(sound);
      }



/*
      else if (ww.equals("HYPO")) {
	//System.out.println("HYPO!!!!!!");
	A.playing(ww, w);
	int x_dim = Integer.valueOf(w.nextToken()).intValue(); 
	int y_dim = Integer.valueOf(w.nextToken()).intValue(); 
	A.drawCheckerboard(x_dim, y_dim);
	//System.out.println("X x Y: " + x_dim + y_dim);
	A.painter();
      }
      else if (ww.equals("HYPO")) {
	System.out.println("HYPO!!!!!!");
	int x = Integer.valueOf(w.nextToken()).intValue(); 
	int y = Integer.valueOf(w.nextToken()).intValue(); 
	System.out.println("going to: " + x + y);
	A.go(x, y);
	A.painter();
      }
*/
    }
    window.addLine(s);
  }
}




















