
import java.net.*;
import java.io.*;

class ServerInput implements Runnable
{
    MudClient client;
    InputStream in;

    ServerInput(MudClient c, InputStream i)
    {
	client = c;
	in = i;
    }

    public void run()
    {
	byte buf[];
	int c;
	StringBuffer cur;

	cur = new StringBuffer();
	
	System.out.println("Running thread");
	while (true)
	{
	    try
	    {
		c = in.read();

		if (c < 0)
		{
		    break;
		}
//		System.out.println("read " + c + ": " +  (char) c);

		if (c == 13)
		{
//		    System.out.println("ignoring CR");
		}
		else if (c == 10)
		{
//		    System.out.println("got NL");
		    client.output(cur.toString());
		    cur.setLength(0);
		    
		}
		else
		{
		    cur.append((char) c);
		}
	    
	    }
	    catch (IOException e)
	    {
		System.out.println("io exception");
		break;
	    }
	    
	}
	client.output("<<DISCONNECTED>>");
	System.out.println("run exiting\n");
    }
}

public class MudClient
{
    Socket conn;
    OutputStream out;
    InputStream in;
    ServerInput input_obj;
    Thread input_thread = null;
    Mudwin window;
    String host;
    int port;

    MudClient(String host, int port)
    {
	this.host = host;
	this.port = port;
    }

    public void connect()
    {
	try {
	    conn = new Socket(host, port);
	    System.out.println("connected to " + host + "/" + port);
	}
	catch ( UnknownHostException e) {
	}
	catch ( IOException e ) {
	}

	try {
	    out = conn.getOutputStream();
	    in = new BufferedInputStream(conn.getInputStream());
	}
	catch (IOException e)
	{
	    System.out.println("Got exception: " + e);
	    return;
	}

	input_obj = new ServerInput(this, in);
	System.out.println("constructor returns");
	input_thread = new Thread(input_obj);
	input_thread.start();
    }

    public void start()
    {
	System.out.println("in start method");
	if (input_thread == null)
	{
	    input_thread = new Thread(input_obj);
	    input_thread.start();
	}
	else
	{
	    input_thread.resume();
	}
    }

    public void stop()
    {
	input_thread.suspend();
    }

    public void destroy()
    {
	input_thread.stop();
    }

    public void setWindow(Mudwin w)
    {
	window = w;
    }

    public void input(String s)
    {
//	System.out.println("client got <" + s + ">");

	byte buf[] = new byte[s.length()];
	s.getBytes(0, s.length(), buf, 0);

	window.addLine(s);

	try {
	    out.write(buf);
	    out.write(10);
	}
	catch (IOException e)
	{
	}
    }

    public void output(String s)
    {
//	System.out.println("client got <" + s + ">");
	window.addLine(s);
    }
}

