/* C code produced by gperf version 2.1p1 (K&R C version, modified by Pavel) */
/* Command-line: pgperf -aCIptT -k1,3,$ keywords.gperf  */

#include "my-ctype.h"

	/* -*- C -*- */

/******************************************************************************
  Copyright (c) 1994 Xerox Corporation.  All rights reserved.
  Portions of this code were written by Stephen White, aka ghond.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted.  Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws.  This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification.  Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    Pavel Curtis
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
    Pavel@Xerox.Com
 *****************************************************************************/

#include "my-string.h"

#include "config.h"
#include "keywords.h"
#include "tokens.h"
#include "utils.h"


#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 9
#define MIN_HASH_VALUE 3
#define MAX_HASH_VALUE 43
/*
   27 keywords
   41 is the maximum key range
*/

static int
hash (register const char *str, register int len)
{
  static const unsigned char hash_table[] =
    {
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 43, 43, 43,
     43, 43, 43, 43, 43, 43, 43, 20, 43,  5,
      0,  0,  0,  5, 43, 30, 43, 20, 43, 10,
      5, 43, 20, 15,  0, 15, 20, 43, 10,  5,
     43, 43, 43, 43, 43, 43, 43, 43,
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 3:
        hval += hash_table[tolower((unsigned char) str[2])];
      case 2:
      case 1:
        hval += hash_table[tolower((unsigned char) str[0])];
    }
  return hval + hash_table[tolower((unsigned char) str[len - 1])];
}

static int
case_strcmp (register const char *str, register const char *key)
{
  int ans = 0;

  while (!(ans = tolower(*str) - (int) *key) && *str)
    str++, key++;

  return ans;
}

const struct keyword *
in_word_set (register const char *str, register int len)
{

  static const struct keyword  wordlist[] =
    {
      {"",}, {"",}, {"",}, 
      {"for", 		tFOR},
      {"",}, 
      {"endif", 		tENDIF},
      {"endfor", 		tENDFOR},
      {"e_range", 	tERROR,	E_RANGE},
      {"endwhile", 	tENDWHILE},
      {"e_recmove", 	tERROR,	E_RECMOVE},
      {"",}, 
      {"e_none", 		tERROR,	E_NONE},
      {"",}, {"",}, {"",}, 
      {"e_div", 		tERROR,	E_DIV},
      {"e_nacc", 		tERROR,	E_NACC},
      {"e_varnf", 	tERROR,	E_VARNF},
      {"e_verbnf", 	tERROR,	E_VERBNF},
      {"else", 		tELSE},
      {"",}, 
      {"elseif", 		tELSEIF},
      {"",}, 
      {"e_maxrec", 	tERROR,	E_MAXREC},
      {"fork", 		tFORK},
      {"",}, 
      {"e_type", 		tERROR,	E_TYPE},
      {"endfork", 	tENDFORK},
      {"e_propnf", 	tERROR,	E_PROPNF},
      {"",}, {"",}, 
      {"return", 		tRETURN},
      {"if", 		tIF},
      {"",}, {"",}, {"",}, 
      {"e_perm", 		tERROR,	E_PERM},
      {"in", 		tIN},
      {"e_invind", 	tERROR,	E_INVIND},
      {"",}, 
      {"while", 		tWHILE},
      {"e_args", 		tERROR,	E_ARGS},
      {"e_quota", 	tERROR,	E_QUOTA},
      {"e_invarg", 	tERROR,	E_INVARG},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
          register const char *s = wordlist[key].name;

          if (*s == tolower(*str) && !case_strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

const struct keyword *
find_keyword(const char *word)
{
    return in_word_set(word, strlen(word));
}

/* $Log$
 */
